//PROFILE-NO
{$O-}
{$D-}
{$Q-}
{$R-}
{$B-}
{$I-}
{$X+}
{$WARNINGS OFF }

unit Profinl;

interface

USES
{$IFDEF LCL }
  Forms,
{$ENDIF }
  Dialogs,
  Windows;
CONST
{$IFDEF WIN32 }
  XXX_PROFI_DLLNAME = 'PROFMEAS.DLL';
  YYY_PROFI_DLLNAME = 'PROFONFO.DLL';
  ZZZ_PROFI_DLLNAME = 'PROFCALI.DLL';
{$ELSE }
  XXX_PROFI_DLLNAME = 'PROFMEAS64.DLL';
  YYY_PROFI_DLLNAME = 'PROFONFO64.DLL';
  ZZZ_PROFI_DLLNAME = 'PROFCALI64.DLL';
{$ENDIF }

// Profiler-Measurement-Functions
PROCEDURE ProfStop;                                       external XXX_PROFI_DLLNAME;
PROCEDURE ProfEnter( mptr  : Pointer; prozNr : LongWord); external XXX_PROFI_DLLNAME;
PROCEDURE ProfExit( prozNr : Integer);                    external XXX_PROFI_DLLNAME;

PROCEDURE ProfActivate;     external XXX_PROFI_DLLNAME;
PROCEDURE ProfDeActivate;   external XXX_PROFI_DLLNAME;
PROCEDURE ProfSetComment    ( comm    : String );
PROCEDURE ProfSetCommentA   ( comm    : PAnsiChar );  external XXX_PROFI_DLLNAME;
PROCEDURE ProfAppendResults ( progEnd : Boolean );external XXX_PROFI_DLLNAME;

// Post-Mortem-Review-Functions
PROCEDURE PomoEnter       ( prozNr : Word );      external XXX_PROFI_DLLNAME;
PROCEDURE PomoExceStr     ( name   : PAnsiChar ); external XXX_PROFI_DLLNAME;
PROCEDURE PomoExce;
PROCEDURE PomoExit        ( prozNr : Word );      external XXX_PROFI_DLLNAME;

// Functions to interrupt and continue measurement for calls which could set the
//  Process idle. Use these calls to implement own Non-measured Calls. If METHODS
//  can set a process idle, the only possibility is, to put these calls into your
//  sources (included by an IFDEF-statement).
//  USE 2 or more spaces between IFDEF and PROFILE, otherwise it will be deleted
//  by the ProDelphi. Example:
//
//  {$IFDEF     PROFILE } StopCounting;     {$ENDIF }
//    ObjectReference.MethodThatMightSetProcessIdle;
//  {$IFDEF     PROFILE } ContinueCounting; {$ENDIF }

// Normal procedures that set the process idle can be handled like the Sleep-
//  function in this unit.
PROCEDURE StopCounting;                           external XXX_PROFI_DLLNAME;
PROCEDURE ContinueCounting;                       external XXX_PROFI_DLLNAME;

// Function for Starting the Online-Operation windoe
PROCEDURE ProfOnlineOperation;                    external YYY_PROFI_DLLNAME;
PROCEDURE ProfCloseOnlineOperation;               external YYY_PROFI_DLLNAME;


// Delphi-Functions that set process idle
{$IFDEF LCL }
PROCEDURE ShowMessage ( CONST Msg  : String );

PROCEDURE ShowMessageFmt(const Msg : string; Params : array of const );

function MessageDlg( const Msg : String;         AType   : TMsgDlgType;
                     AButtons  : TMsgDlgButtons; HelpCtx : Longint ) : TModalResult; overload;

function MessageDlg( const aCaption: string; const aMsg: string; DlgType: TMsgDlgType;
                     Buttons: TMsgDlgButtons; HelpCtx: LongInt):TModalResult; overload;

function MessageDlg( const aCaption: string; const aMsg: string; DlgType: TMsgDlgType;
                     Buttons: TMsgDlgButtons; HelpCtx: LongInt;  DefaultButton: TMsgDlgBtn):TModalResult; overload;

function MessageDlg( const aMsg: string; DlgType: TMsgDlgType; Buttons: TMsgDlgButtons;
                     HelpCtx: LongInt; DefaultButton: TMsgDlgBtn):TModalResult; overload;

function MessageDlg( const aCaption: string; const aMsg: string; DlgType: TMsgDlgType;
                           Buttons: TMsgDlgButtons; const HelpKeyword: string):TModalResult; overload;

function  MessageDlgPos( const Msg : string;         DlgType : TMsgDlgType;
                         Buttons   : TMsgDlgButtons; HelpCtx : Longint;
                         X, Y      : Integer) : Integer;

function MessageDlgPosHelp( const Msg : string;         DlgType : TMsgDlgType;
                            Buttons   : TMsgDlgButtons; HelpCtx : Longint;
                            X, Y      : Integer;        const HelpFileName : string)
                           : Integer;


// Delphi-TApplication-Functions that set process idle (handled in DLL)
VAR
  ProcessMessages : Procedure Of Object;
  HandleMessage : Procedure Of Object;

FUNCTION  AMessageBox( Text, Caption   : PChar;
                       Flags : Longint): Integer;
{$ENDIF }
// Windows-Functions that set process idle
{ FUNCTION  DispatchMessage(CONST lpMsg  : TMsg) : Longint; }
FUNCTION  DialogBoxIndirect( hInstance  : HINST; const lpDialogTemplate : LPCDlgTemplate;
                             hWndParent : HWND;        lpDialogFunc     : DlgProc): Integer;
FUNCTION  DialogBox( hInstance  : HINST; lpTemplate   : PChar;
                     hWndParent : HWND;  lpDialogFunc : DlgProc): Integer;
FUNCTION  MessageBox ( hWnd : HWND; lpText, lpCaption: PChar; uType : UINT ) : Integer;
FUNCTION  MessageBoxEx( hWnd : HWND; lpText, lpCaption: PChar; uType : UINT; lang : Word ) : Integer;
FUNCTION  SignalObjectAndWait ( h1, h2 : THandle;
                                ms     : DWord;
                                al     : BOOL) : DWORD;

FUNCTION  WaitForSingleObject ( h1     : THandle;
                                MS     : DWORD ) : DWORD;

FUNCTION  WaitForSingleObjectEx ( h1   : THandle;
                                  MS   : DWORD;
                                  al   : BOOL ) : DWORD;

FUNCTION  WaitForMultipleObjects ( ct  : DWORD;
                                   CONST pH : PWOHandleArray;
                                   wait     : BOOL;
                                   ms       : DWORD ) : DWORD;

FUNCTION  WaitForMultipleObjectsEx ( ct  : DWORD;
                                     CONST pH : PHandle;
                                     wait     : BOOL;
                                     ms       : DWORD;
                                     al       : Boolean) : DWORD;

FUNCTION  MsgWaitForMultipleObjects ( ct      : DWORD;
                                      VAR pHandles;
                                      wait    : BOOL;
                                      ms      : DWORD;
                                      wm      : DWORD ) : DWORD;

FUNCTION  MsgWaitForMultipleObjectsEx ( ct     : DWORD;
                                        VAR pHandles;
                                        ms     : DWORD;
                                        wm     : DWORD;
                                        fl     : DWORD ) : DWORD;

PROCEDURE Sleep   (zeit : DWORD );
FUNCTION  SleepEx (zeit : DWORD; alertable : BOOL ) : DWORD;
FUNCTION  WaitCommEvent ( hd  : THandle; VAR em : DWORD;
                          lpo : POverlapped ) : BOOL;
FUNCTION  WaitForInputIdle ( hp : THandle; ms : DWORD ) : DWORD;
FUNCTION  WaitMessage : BOOL;

PROCEDURE Halt; Overload;
PROCEDURE Halt(ecode : Integer); Overload;

FUNCTION  WaitNamedPipe ( np : PAnsiChar; ms : DWORD ) : BOOL;

{$IFDEF LCL }
TYPE
  TProfIntApp = Class
    PROCEDURE ProcessMessages;
    PROCEDURE HandleMessage;
  end;
VAR
  ProfintApplication : TProfIntApp;
{$ENDIF }


IMPLEMENTATION
USES
  SysUtils;

  
  
// Profiler-Internal-Functions, DO NOT USE
FUNCTION  ProfGlobalInit1 : Boolean;              external XXX_PROFI_DLLNAME;
PROCEDURE ProfGlobalInit2 ( j : Integer );        external XXX_PROFI_DLLNAME;
PROCEDURE ProfUnInitTimer;                        external XXX_PROFI_DLLNAME;
FUNCTION  ProfIsInitialised : Integer;            external XXX_PROFI_DLLNAME;
FUNCTION  ProfMustBeUnInitialised : Integer;      external XXX_PROFI_DLLNAME;

// Calibration - Function - DO NOT USE
PROCEDURE CalcQPCTime802;                         external ZZZ_PROFI_DLLNAME;
PROCEDURE ProfSetDelphiVersion ( vers : Integer );external ZZZ_PROFI_DLLNAME;
{$ASMMODE intel}
FUNCTION RDTSC : Int64;
BEGIN
ASM
  DW 310FH;
END;
END;

// Check if CPU is intel-Compatible
PROCEDURE PruefeKompatibilitaet;
BEGIN
  Try
    RDTSC;
  Except
    Windows.MessageBox(0, 'This CPU is not Intel-Compatible', 'ProDelphi - ERROR', MB_OK);
    halt(0);
  End;
END;
{$IFDEF LCL }
PROCEDURE ShowMessage ( CONST Msg  : String );
BEGIN
  StopCounting;
  Dialogs.ShowMessage(Msg);
  ContinueCounting;
END;

PROCEDURE ShowMessageFmt(const Msg : string; Params : array of const );
BEGIN
  StopCounting;
  Dialogs.ShowMessageFmt(Msg, Params);
  ContinueCounting;
END;

FUNCTION AMessageBox( Text, Caption     : PChar;
                      Flags : LongInt ) : Integer;
BEGIN
  StopCounting;
  Result := Application.MessageBox(Text, Caption,Flags);
  ContinueCounting;
END;

PROCEDURE TProfIntApp.HandleMessage;
BEGIN
  ProfStop; Try; ProfEnter(NIL,1);
  Application.HandleMessage;
  finally; ProfExit(1); end;
END;

PROCEDURE TProfIntApp.ProcessMessages;
BEGIN
  ProfStop; Try; ProfEnter(NIL,1);
  Application.ProcessMessages;
  finally; ProfExit(1); end;
END;

FUNCTION MessageDlg( const Msg : String;         AType   : TMsgDlgType;
                     AButtons  : TMsgDlgButtons; HelpCtx : Longint ) : TModalResult;
BEGIN
  StopCounting;
  Result := Dialogs.MessageDlg(Msg,
                               AType,
                               AButtons,
                               HelpCtx);
  ContinueCounting;
END;

function MessageDlg( const aCaption: string; const aMsg: string; DlgType: TMsgDlgType;
                     Buttons: TMsgDlgButtons; HelpCtx: LongInt):TModalResult;
BEGIN
  StopCounting;
  Result := Dialogs.MessageDlg(aCaption,
                               aMsg,
                               DlgType,
                               Buttons,
                               HelpCtx);
  ContinueCounting;
END;

function MessageDlg( const aCaption: string; const aMsg: string; DlgType: TMsgDlgType;
                     Buttons: TMsgDlgButtons; HelpCtx: LongInt;  DefaultButton: TMsgDlgBtn):TModalResult;
BEGIN
  StopCounting;
  Result := Dialogs.MessageDlg(aCaption,
                               aMsg,
                               DlgType,
                               Buttons,
                               HelpCtx,
                               DefaultButton);
  ContinueCounting;
END;

function MessageDlg( const aMsg: string; DlgType: TMsgDlgType; Buttons: TMsgDlgButtons;
                     HelpCtx: LongInt; DefaultButton: TMsgDlgBtn):TModalResult;
BEGIN
  StopCounting;
  Result := Dialogs.MessageDlg(aMsg,
                               DlgType,
                               Buttons,
                               HelpCtx,
                               DefaultButton);
  ContinueCounting;
END;

function MessageDlg( const aCaption: string; const aMsg: string; DlgType: TMsgDlgType;
                           Buttons: TMsgDlgButtons; const HelpKeyword: string):TModalResult;
BEGIN
  StopCounting;
  Result := Dialogs.MessageDlg(aCaption,
                               aMsg,
                               DlgType,
                               Buttons,
                               HelpKeyword);
  ContinueCounting;
END;


FUNCTION MessageDlgPos( const Msg : string;         DlgType : TMsgDlgType;
                        Buttons   : TMsgDlgButtons; HelpCtx: Longint;
                        X, Y      : Integer) : Integer;
BEGIN
  StopCounting;
  Result := Dialogs.MessageDlgPos(Msg,
                                  DlgType,
                                  Buttons,
                                  HelpCtx,
                                  X, Y);
  ContinueCounting;
END;

function MessageDlgPosHelp( const Msg : string;         DlgType      : TMsgDlgType;
                            Buttons   : TMsgDlgButtons; HelpCtx      : Longint;
                            X, Y      : Integer;  const HelpFileName : string)
                           : Integer;
BEGIN
  StopCounting;
  Result := Dialogs.MessageDlgPosHelp(Msg,
                                      DlgType,
                                      Buttons,
                                      HelpCtx,
                                      X, Y,
                                      HelpFileName);
  ContinueCounting;
END;
{$ENDIF }
FUNCTION  DialogBoxIndirect( hInstance  : HINST; const lpDialogTemplate : LPCDlgTemplate;
                             hWndParent : HWND;        lpDialogFunc     : DlgProc): Integer;
BEGIN
  StopCounting;
  Result := Windows.DialogBoxIndirect(hInstance, lpDialogTemplate, hWndParent, lpDialogFunc);
  ContinueCounting;
END;

FUNCTION  DialogBox( hInstance  : HINST; lpTemplate   : PChar;
                     hWndParent : HWND;  lpDialogFunc : DlgProc): Integer;
BEGIN
  StopCounting;
  Result := Windows.DialogBox(hInstance, lpTemplate, hWndParent, lpDialogFunc);
  ContinueCounting;
END;

FUNCTION MessageBox ( hWnd : HWND; lpText, lpCaption: PChar; uType : UINT ) : Integer;
BEGIN
  StopCounting;
  Result := Windows.MessageBox(hWnd, lpText, lpCaption, uType);
  ContinueCounting;
END;

FUNCTION MessageBoxEx ( hWnd : HWND; lpText, lpCaption: PChar; uType : UINT; lang : Word ) : Integer;
BEGIN
  StopCounting;
  Result := Windows.MessageBoxEx(hWnd, lpText, lpCaption, uType, lang);
  ContinueCounting;
END;


PROCEDURE Sleep( zeit : DWORD );
BEGIN
  StopCounting;
  Windows.Sleep(zeit);
  ContinueCounting;
END;

FUNCTION SleepEx( zeit : DWORD; alertable : BOOL ) : DWORD;
BEGIN
  StopCounting;
  Result := Windows.SleepEx(zeit, alertable);
  ContinueCounting;
END;

FUNCTION SignalObjectAndWait ( h1, h2 : THandle;
                               ms     : DWord;
                               al     : BOOL) : DWORD;
BEGIN
  StopCounting;
  Result := Windows.SignalObjectAndWait(h1, h2, ms, al);
  ContinueCounting;
END;

FUNCTION WaitForSingleObject ( h1     : THandle;
                               MS     : DWORD ) : DWORD;
BEGIN
  StopCounting;
  Result := Windows.WaitForSingleObject ( h1, MS );
  ContinueCounting;
END;

FUNCTION WaitForSingleObjectEx ( h1   : THandle;
                                 MS   : DWORD;
                                 al   : BOOL ) : DWORD;
BEGIN
  StopCounting;
  Result := Windows.WaitForSingleObjectEx (h1, MS, al);
  ContinueCounting;
END;

FUNCTION WaitForMultipleObjects ( ct  : DWORD;
                                  CONST pH : PWOHandleArray;
                                  wait     : BOOL;
                                  ms       : DWORD ) : DWORD;
BEGIN
  StopCounting;
  Result := Windows.WaitForMultipleObjects(ct, pH, wait, ms);
  ContinueCounting;
END;

FUNCTION WaitForMultipleObjectsEx ( ct  : DWORD;
                                    CONST pH : PHandle;
                                    wait     : BOOL;
                                    ms       : DWORD;
                                    al       : Boolean ) : DWORD;
BEGIN
  StopCounting;
  Result := Windows.WaitForMultipleObjectsEx(ct, pH, wait, ms, al);
  ContinueCounting;
END;

FUNCTION MsgWaitForMultipleObjects ( ct     : DWORD;
                                     VAR pHandles;
                                     wait   : BOOL;
                                     ms     : DWORD;
                                     wm     : DWORD ) : DWORD;
BEGIN
  StopCounting;
  Result := Windows.MsgWaitForMultipleObjects(ct, pHandles, wait, ms, wm);
  ContinueCounting;
END;

FUNCTION MsgWaitForMultipleObjectsEx ( ct     : DWORD;
                                       VAR pHandles;
                                       ms     : DWORD;
                                       wm     : DWORD;
                                       fl     : DWORD ) : DWORD;
BEGIN
  StopCounting;
  Result := Windows.MsgWaitForMultipleObjectsEx(ct, pHandles, ms, wm, fl);
  ContinueCounting;
END;

FUNCTION WaitCommEvent ( hd : THandle; VAR em : DWORD; lpo : POverlapped ) : BOOL;
BEGIN
  StopCounting;
  Result := Windows.WaitCommEvent(hd, em, lpo);
  ContinueCounting;
END;

FUNCTION WaitForInputIdle ( hp : THandle; ms : DWORD ) : DWORD;
BEGIN
  StopCounting;
  Result := Windows.WaitForInputIdle(hp, ms);
  ContinueCounting;
END;

FUNCTION WaitMessage : BOOL;
BEGIN
  StopCounting;
  Result := Windows.WaitMessage;
  ContinueCounting;
END;

FUNCTION WaitNamedPipe ( np : PAnsiChar; ms : DWORD ) : BOOL;
BEGIN
  StopCounting;
  Result := Windows.WaitNamedPipe(np, ms);
  ContinueCounting;
END;

PROCEDURE PomoExce;
VAR
  exnames : String;
  exname  : Array[0..199] OF Char;
  ExOb    : TObject;
BEGIN
  exname[0] := Char(0);
  ExOb := ExceptObject;
  IF Assigned(ExOb) THEN BEGIN
    IF ExceptObject IS Exception THEN BEGIN
      exnames := Exception(ExceptObject).Message;
      StrPLCopy(exname, exnames, SizeOf(exname) DIV SizeOf(Char));
    END;
  END;
  PomoExceStr(exname);
END;

PROCEDURE ProfSetComment( comm : String );
VAR
  comment  : Array[0..255] OF AnsiChar;
  commenta : AnsiString;
BEGIN
  commenta := UTF8Encode(comm);
  StrPLCopy(comment, commenta, SizeOf(comment));
  ProfSetCommentA(comment);
END;

PROCEDURE Finalisierung(comm : String);
BEGIN
  IF ProfMustBeUnInitialised = 1 THEN BEGIN
    ProfSetComment(comm);
    ProfAppendResults(TRUE);
    ProfUnInitTimer;
{$IFDEF LCL }
    ProfintApplication.Free;
{$ENDIF }
  END;
END;

PROCEDURE Halt;
BEGIN
  Finalisierung('Ending by Halt; call');
  ProfCloseOnlineOperation;
  System.Halt;
END;

PROCEDURE Halt(ecode : Integer);
BEGIN
  Finalisierung('Ending by Halt(error code); call');
  ProfCloseOnlineOperation;
  System.Halt(ecode);
END;

INITIALIZATION
  IF ProfIsInitialised = 1 THEN BEGIN
    PruefeKompatibilitaet;
    IF ProfGlobalInit1 = TRUE THEN BEGIN
      CalcQPCTime802;
    END;
    ProfGlobalInit2(0);
    ProfSetComment('None');
{$IFDEF LCL }
    ProfintApplication := TProfIntApp.Create;
  {$IFDEF fpc_delphi }
    ProcessMessages := ProfintApplication.ProcessMessages;
    HandleMessage   := ProfintApplication.HandleMessage;
  {$ELSE }
    ProcessMessages := @ProfintApplication.ProcessMessages;
    HandleMessage   := @ProfintApplication.HandleMessage;
  {$ENDIF }
{$ENDIF }
  END;
FINALIZATION
  Finalisierung('At finishing application');
end.


